#include "draw.h"

/*********************************************
  Хåؿ
*********************************************/

/*
  RandomLine : ʬ褹

  GtkWidget *widget : оݥå
  gpointer gp : GPSetBaseؤΥϥɥ
*/
static void RandomLine( GtkWidget *widget, gpointer gp )
{
  GPSetBase* pset = *( (GPSetBase**)gp );

  Graph::GLine line;
  line.drawSize = pset->size();
  for ( unsigned int i = 0 ; i < RANDOM_COUNT ; i++ ) {
    line.coord0 = Coord<int>( (int) ( (double)rand() / ( (double)RAND_MAX + 1 ) * ( Draw->pixbufWidth() - 1 ) ),
			      (int) ( (double)rand() / ( (double)RAND_MAX + 1 ) * ( Draw->pixbufHeight() - 1 ) ) );
    line.coord1 = Coord<int>( (int) ( (double)rand() / ( (double)RAND_MAX + 1 ) * ( Draw->pixbufWidth() - 1 ) ),
			      (int) ( (double)rand() / ( (double)RAND_MAX + 1 ) * ( Draw->pixbufHeight() - 1 ) ) );
    line( *pset );
  }
  Draw->reflesh();
}

/*
  RandomEllipse : ʱߤ褹

  GtkWidget *widget : оݥå
  gpointer gp : GPSetBaseؤΥϥɥ
*/
static void RandomEllipse( GtkWidget *widget, gpointer gp )
{
  GPSetBase* pset = *( (GPSetBase**)gp );
  if ( pset == PSetFunc[PATTERN].pset )
    pset = PSetFunc[NORMAL].pset;

  Graph::GEllipse ellipse;
  ellipse.drawSize = pset->size();
  for ( unsigned int i = 0 ; i < RANDOM_COUNT ; i++ ) {
    ellipse.origin = Coord<int>( (int) ( (double)rand() / ( (double)RAND_MAX + 1 ) * ( Draw->pixbufWidth() - 1 ) ),
				 (int) ( (double)rand() / ( (double)RAND_MAX + 1 ) * ( Draw->pixbufHeight() - 1 ) ) );
    ellipse.r = (unsigned int)( (double)rand() / ( (double)RAND_MAX + 1 ) * ( Draw->pixbufWidth() - 1 ) );
    do {
      ellipse.k.x = (unsigned int) ( (double)rand() / ( (double)RAND_MAX + 1 ) * ( Draw->pixbufWidth() - 1 ) );
      ellipse.k.y = (unsigned int) ( (double)rand() / ( (double)RAND_MAX + 1 ) * ( Draw->pixbufHeight() - 1 ) );
    } while ( ellipse.k.x <= 0 || ellipse.k.y <= 0 );
    ellipse( *pset );
  }
  Draw->reflesh();
}

/*
  delete_event : ɥĤȤΥ٥ȤФ륳Хå
                 FALSE֤destroyʥ뤬ȯԤ

  GtkWidget* widget : оݥå
  GdkEvent* event : ٥Ȥ
  gpointer data : 桼ѥǡ
*/
static gboolean delete_event( GtkWidget* widget, GdkEvent* event, gpointer data )
{
  return( FALSE );
}

/*
  destroy : destroyʥΥХå

  GtkWidget* widget : оݥå
  gpointer data : 桼ѥǡ
*/
static void destroy( GtkWidget* widget, gpointer data )
{
  gtk_main_quit();
}

/*
  getRGB : ѹΥХå

  GtkScale *scale : оݥ륦å
  gdouble value : θ
  gpointer col : ѹоݤοʬ(RGB)
*/
static gchar* getRGB( GtkScale *scale, gdouble value, gpointer col )
{
  *( (unsigned char*)col ) = (unsigned char)value;
  RGB rgb( RgbTable[0].col, RgbTable[1].col, RgbTable[2].col );

  dynamic_cast<GPSet*>( PSetFunc[NORMAL].pset )->col = rgb;
  dynamic_cast<GPSet*>( PSetFunc[XOR].pset )->col = rgb;
  dynamic_cast<GPSet*>( PSetFunc[PATTERN].pset )->col = rgb;

  return( 0 );
}

/*
  getBright : ѹΨѹΥХå

  GtkScale *scale : оݥ륦å
  gdouble value : θ
  gpointer gp : 桼ѥǡ
*/
static gchar* getBright( GtkScale *scale, gdouble value, gpointer gp )
{
  dynamic_cast<GBrightSet*>( PSetFunc[BRIGHTNESS].pset )->rate = (double)value;

  return( 0 );
}

/*
  getCount : ʬѹΥХå

  GtkScale *scale : оݥ륦å
  gdouble value : θ
  gpointer gp : 桼ѥǡ
*/
static gchar* getCount( GtkScale *scale, gdouble value, gpointer gp )
{
  RANDOM_COUNT = (unsigned int)value;

  return( 0 );
}

/*
  getPattern : 饤ѥѹΥХå

  GtkScale *scale : оݥ륦å
  gpointer pattern : 򤵤줿饤ѥ
*/
static gchar* getPattern( GtkScale *scale, gpointer pattern )
{
  dynamic_cast<GPatternSet*>( PSetFunc[PATTERN].pset )->pattern = *( (unsigned char*)pattern );

  return( 0 );
}

/*
  changeSelection : ѥ٥ѹΥХå

  GtkWidget *widget : оݥå
  gpointer gp : ѹѥ٥
*/
static void changeSelection( GtkWidget *widget, gpointer gp )
{
  NotDrawType* notDraw = (NotDrawType*)gp;

  for ( unsigned int i = 0 ; i < NOT_DRAW_SIZE ; ++i ) {
    if ( ( NotDraws[i].event )->isConnected() )
      ( NotDraws[i].event )->disconnect();
  }

  CurDraw = notDraw->draw;
  notDraw->event->connect();
}

/*
  changePSet : Ѵؿ֥ѹΥХå

  GtkWidget *widget : оݥå
  gpointer gp : ѹѴؿ֥
*/
static void changePSet( GtkWidget *widget, gpointer gp )
{
  CurPSet = (GPSetBase*)gp;

  for ( unsigned int i = 0 ; i < NOT_DRAW_SIZE ; ++i ) {
    if ( CurPSet == PSetFunc[PATTERN].pset && i != LINE )
      ( NotDraws[i].draw )->bind( *( PSetFunc[NORMAL].pset ) );
    else
      ( NotDraws[i].draw )->bind( *CurPSet );
  }
}

/*********************************************
  ؿ
*********************************************/

/*
  createPSet : Ѵؿ֥Ȥκ
*/
static void createPSet()
{
  PSetFunc[NORMAL].pset     = new GPSet( *Draw, RGB( RgbTable[0].col, RgbTable[1].col, RgbTable[2].col ) );
  PSetFunc[XOR].pset        = new GXorSet( *Draw, RGB( RgbTable[0].col, RgbTable[1].col, RgbTable[2].col ) );
  PSetFunc[NOT].pset        = new GNotSet( *Draw );
  PSetFunc[BRIGHTNESS].pset = new GBrightSet( *Draw, DEFAULT_BRIGHTNESS );
  PSetFunc[PATTERN].pset    = new GPatternSet( *Draw, RGB( RgbTable[0].col, RgbTable[1].col, RgbTable[2].col ), DEFAULT_PATTERN );

  CurPSet = PSetFunc[NORMAL].pset;
}

/*
  createNotDraw : ѥ٥Ȥκ
*/
static void createNotDraw()
{
  NotDraws[LINE].draw     = new NotLine( *CurPSet );
  NotDraws[LINE].event    = new DrawingArea_2PassSelectionEvent( *( NotDraws[LINE].draw ) );
  NotDraws[CIRCLE].draw   = new NotCircle( *CurPSet );
  NotDraws[CIRCLE].event  = new DrawingArea_2PassSelectionEvent( *( NotDraws[CIRCLE].draw ) );
  NotDraws[BOX].draw      = new NotBox( *CurPSet );
  NotDraws[BOX].event     = new DrawingArea_2PassSelectionEvent( *( NotDraws[BOX].draw ) );
  NotDraws[ELLIPSE].draw  = new NotEllipse( *CurPSet );
  NotDraws[ELLIPSE].event = new DrawingArea_2PassSelectionEvent( *( NotDraws[ELLIPSE].draw ) );
  NotDraws[ARC].draw      = new NotCircleWithDia( *CurPSet );
  NotDraws[ARC].event     = new DrawingArea_TriPointSelectionEvent( *( dynamic_cast<NotCircleWithDia*>( NotDraws[ARC].draw ) ) );

  CurDraw = NotDraws[LINE].draw;
  ( NotDraws[LINE].event )->connect();
}

/*********************************************
  Ѵؿ
*********************************************/

/*
  deletePSet : Ѵؿ֥Ȥ˴
*/
static void deletePSet()
{
  for ( unsigned int i = 0 ; i < PSET_SIZE ; ++i )
    delete PSetFunc[i].pset;
}

/*
  deleteNotDraw : ѥ٥Ȥ˴
*/
static void deleteNotDraw()
{
  for ( unsigned int i = 0 ; i < NOT_DRAW_SIZE ; ++i ) {
    delete NotDraws[i].draw;
    delete NotDraws[i].event;
  }
}

/********************************************
  ᥤ롼

  int argc : ο
  char* argv[] : Υꥹ
********************************************/
int main( int argc, char* argv[] )
{
  using namespace Graph;

  try
  {
    gtk_init( &argc, &argv );
    srand( (unsigned)time(NULL) );

    /* ΰ */
    Draw = new DrawingArea( Coord<unsigned int>( 800, 600 ) );
    Draw->show();
    createPSet();
    createNotDraw();

    /* ᥤ󥦥å */
    GtkWidget* window = gtk_window_new( GTK_WINDOW_TOPLEVEL );
    g_signal_connect( G_OBJECT( window ), "delete_event", G_CALLBACK( delete_event ), NULL );
    g_signal_connect( G_OBJECT( window ), "destroy", G_CALLBACK( destroy ), NULL );
    gtk_window_resize( GTK_WINDOW( window ), 800, 800 );

    /* ѥ֥ */
    GtkWidget* condBox = gtk_hbox_new( FALSE, 0 );

    // GUI
    GtkWidget* colTable = gtk_table_new( 2, RGB_TABLE_SIZE + 1, FALSE );
    for ( unsigned int i = 0 ; i < RGB_TABLE_SIZE ; ++i ) {
      GtkWidget* label = gtk_label_new( RgbTable[i].ident );
      gtk_table_attach_defaults( GTK_TABLE( colTable ), label, 0, 1, i, i + 1 );
      GtkWidget* scale = gtk_hscale_new_with_range( 0, 255, 1 );
      gtk_range_set_value( GTK_RANGE( scale ), 255 );
      gtk_scale_set_value_pos( GTK_SCALE( scale ), GTK_POS_RIGHT );
      g_signal_connect( G_OBJECT( scale ), "format-value", G_CALLBACK( getRGB ), &( RgbTable[i].col ) );
      gtk_table_attach_defaults( GTK_TABLE( colTable ), scale, 1, 2, i, i + 1 );
    }
    gtk_box_pack_end( GTK_BOX( condBox ), colTable, TRUE, TRUE, 0 );

    // ¾GUI
    GtkWidget* miscTable = gtk_table_new( 2, sizeof( Pattern ) / sizeof( Pattern[0] ) + 2, FALSE );

    // ʬ褹
    gtk_table_attach_defaults( GTK_TABLE( miscTable ), gtk_label_new( "count" ), 0, 1, 0, 1 );
    GtkWidget* cntScale = gtk_hscale_new_with_range( 0, 5000, 100 );
    g_signal_connect( G_OBJECT( cntScale ), "format-value", G_CALLBACK( getCount ), 0 );
    gtk_range_set_value( GTK_RANGE( cntScale ), 1000 );
    gtk_scale_set_value_pos( GTK_SCALE( cntScale ), GTK_POS_RIGHT );
    gtk_table_attach_defaults( GTK_TABLE( miscTable ), cntScale, 1, 2, 0, 1 );

    // 뤵
    gtk_table_attach_defaults( GTK_TABLE( miscTable ), gtk_label_new( "brightness" ), 0, 1, 1, 2 );
    GtkWidget* brtScale = gtk_hscale_new_with_range( 0.0, 2.0, 0.1 );
    g_signal_connect( G_OBJECT( brtScale ), "format-value", G_CALLBACK( getBright ), 0 );
    gtk_range_set_value( GTK_RANGE( brtScale ), DEFAULT_BRIGHTNESS );
    gtk_scale_set_value_pos( GTK_SCALE( brtScale ), GTK_POS_RIGHT );
    gtk_table_attach_defaults( GTK_TABLE( miscTable ), brtScale, 1, 2, 1, 2 );

    // 饤ѥ
    gtk_table_attach_defaults( GTK_TABLE( miscTable ), gtk_label_new( "pattern" ), 0, 1, 2, 5 );
    GtkWidget* radio = 0;
    for ( unsigned int i = 0 ; i < sizeof( Pattern ) / sizeof( Pattern[0] ) ; ++i ) {
      radio = gtk_radio_button_new_with_label_from_widget( GTK_RADIO_BUTTON( radio ), Pattern[i].ident );
      g_signal_connect( G_OBJECT( radio ), "toggled", G_CALLBACK( getPattern ), &( Pattern[i].pattern ) );
      gtk_table_attach_defaults( GTK_TABLE( miscTable ), radio, 1, 2, i + 2, i + 3 );
    }

    gtk_box_pack_end( GTK_BOX( condBox ), miscTable, TRUE, TRUE, 0 );

    /* ʬѥ˥塼 */
    MenuBar menuBar;

    Menu selMenu( "Selection" );
    menuBar.addMenu( selMenu );
    for ( unsigned int i = 0 ; i < NOT_DRAW_SIZE ; ++i )
      selMenu.addItem( NotDraws[i].ident, G_CALLBACK( changeSelection ), (void*)( &NotDraws[i] ) );

    Menu psetMenu( "PSet" );
    menuBar.addMenu( psetMenu );
    for ( unsigned int i = 0 ; i < PSET_SIZE ; ++i )
      psetMenu.addItem( PSetFunc[i].ident, G_CALLBACK( changePSet ), (void*)( PSetFunc[i].pset ) );

    Menu randomMenu( "Random Draw" );
    menuBar.addMenu( randomMenu );
    randomMenu.addItem( "Line", G_CALLBACK( RandomLine ), (void**)( &CurPSet ) );
    randomMenu.addItem( "Ellipse", G_CALLBACK( RandomEllipse ), (void**)( &CurPSet ) );

    /* åȤ */
    GtkWidget* vbox = gtk_table_new( 1, 3, FALSE );
    gtk_table_attach( GTK_TABLE( vbox ), menuBar.widget(), 0, 1, 0, 1, (GtkAttachOptions)( GTK_EXPAND | GTK_FILL ), (GtkAttachOptions)( GTK_SHRINK ), 0, 0 );
    gtk_table_attach( GTK_TABLE( vbox ), condBox, 0, 1, 1, 2, (GtkAttachOptions)( GTK_EXPAND | GTK_FILL ), (GtkAttachOptions)( GTK_SHRINK ), 0, 0 );
    gtk_table_attach_defaults( GTK_TABLE( vbox ), Draw->widget(), 0, 1, 2, 3 );

    gtk_container_add( GTK_CONTAINER( window ), vbox );
    gtk_widget_show_all( window );

    gtk_main();

    deletePSet();
    deleteNotDraw();
  }
  catch( exception& e ) {
    cout << "fail : " << e.what() << endl;
    deletePSet();
    deleteNotDraw();
    return( 0 );
  }
  catch( ... ) {
    cout << "fail : Unknown excaption." << endl;
    deletePSet();
    deleteNotDraw();
    return( 0 );
  }

  return( 0 );
}
