#ifndef DRAW_H
#define DRAW_H

#include "DrawingMethod.h"

using namespace GtkPP;
using namespace Graph;

/**************************************************************
  
**************************************************************/

enum PSetIndex { // Ѵؿ֥
  NORMAL = 0,
  XOR = 1,
  NOT = 2,
  BRIGHTNESS = 3,
  PATTERN = 4,
};

enum DrawIndex { // ѥ٥
  LINE = 0,
  CIRCLE = 1,
  BOX = 2,
  ELLIPSE = 3,
  ARC = 4,
};

/**************************************************************
  ¤Τ
**************************************************************/

// RGBData : GUIǤοѹ¤
typedef struct RGBData {
  char* ident;       // ̻
  unsigned char col; // 
} RGBData;

// PatternData : GUIǤΥ饤ѥѹ¤
typedef struct PatternData {
  char* ident;           // ̻
  unsigned char pattern; // 饤ѥ
} PatternData;

// PSetFunc : ؿ֥Ͽѹ¤
typedef struct PSetFuncType {
  char* ident;     // ̻
  GPSetBase* pset; // ؿ֥ȤؤΥݥ
} PSetFuncType;

// NotDrawType : ѥ٥ȹ¤
typedef struct NotDrawType {
  char* ident;               // ̻
  NotDraw* draw;             // ȿžѴؿ֥ȤؤΥݥ
  GtkPP::GtkCallback* event; // 襤٥ȤؤΥݥ
} NotDrawType;

/**************************************************************
  Хѿ
**************************************************************/

static DrawingArea* Draw; // 襨ꥢ

// 迧
static RGBData RgbTable[] = {
  { "red", 255, },
  { "green", 255, },
  { "blue", 255, },
};
const unsigned int RGB_TABLE_SIZE = sizeof( RgbTable ) / sizeof( RgbTable[0] );

// 뤵Υǥե
const double DEFAULT_BRIGHTNESS = 1.0;

// 饤ѥ
static PatternData Pattern[] = {
  { "dot-line", 0xAA, },
  { "dash-line", 0xEE, },
  { "line", 0xFF, },
};
const unsigned char DEFAULT_PATTERN = Pattern[0].pattern;

// 
static unsigned int RANDOM_COUNT;

// ؿ֥
static PSetFuncType PSetFunc[] = {
  { "Normal",     0, },
  { "XOR",        0, },
  { "NOT",        0, },
  { "Brightness", 0, },
  { "Pattern",    0, },
};
const unsigned int PSET_SIZE = sizeof( PSetFunc ) / sizeof( PSetFunc[0] );
static GPSetBase* CurPSet = 0; // 򤵤Ƥؿ֥

// ѥ٥
static NotDrawType NotDraws[] = {
  { "Line",         0, 0, },
  { "Circle",       0, 0, },
  { "Box",          0, 0, },
  { "Ellipse",      0, 0, },
  { "Arc(by dia.)", 0, 0, },
};
const unsigned int NOT_DRAW_SIZE = sizeof( NotDraws ) / sizeof( NotDraws[0] );
static NotDraw* CurDraw = 0; // 򤵤Ƥѥ٥

#endif
