#include "gadget.h"

namespace Gadget
{
  /*
    c_copy : stringchar*ؤѴ

    const string& s : оʸ
    char* c : Ѵ̤ϿcharؤΥݥ
    size_t size : cΥ
  */
  void c_copy( const string& s, char* c, size_t size )
  {
    if ( s.length() == 0 || size == 0 ) return;
    size_t i = ( s.length() + 1 > size ) ? size - 1 : s.length();
    s.copy( c, i );
    c[i] = 0;
  }

  /*
    trim : ʸξüˤʸ

    const string& st : оʸ

     : ʸ
  */
  string trim( const string& st )
  {
    unsigned int s, e;
    for ( s = 0 ; s < st.length() ; s++ )
      if ( st[s] != ' ' && st[s] != '\t' )
	break;
    if ( s == st.length() )
      return( "" );

    for ( e = st.length() - 1 ; e > 0 ; e-- )
      if ( st[e] != ' ' && st[e] != '\t' )
	break;

    return( st.substr( s, e - s + 1 ) );
  }

  /*
    cmp_str : ʸ

    const string& s1, s2 : оʸ
    bool ignoreCase : trueʸʸΰ㤤̵뤹

     : s1 < s2 ... -1 ; s1 > s2 ... 1 ; s1 = s2 ... 0
  */
  int cmp_str( const string& s1, const string& s2, bool ignoreCase )
  {
    string::const_iterator p1 = s1.begin();
    string::const_iterator p2 = s2.begin();

    while ( p1 != s1.end() && p2 != s2.end() ) {
      unsigned char c1 = *p1++;
      unsigned char c2 = *p2++;

      if ( ignoreCase ) {
	c1 = toupper( c1 );
	c2 = toupper( c2 );
      }

      if ( c1 != c2 ) return( ( c1 < c2 ) ? -1 : 1 );
    }

    return( ( s1.size() == s2.size() ) ? 0 :
	    ( ( s1.size() < s2.size() ) ? -1 : 1 ) );
  }

  /*
    vector< string >* split ʸʸɤǶڤ

    const string& s : ʬоݤʸ
    char c : ʬ֤򼨤ʸ

     : ʬ䤷ʸΥ٥
  */
  vector< string >* split( const string& s, char c )
  {
    vector< string >* vecStr = new vector< string >();
    string::size_type i = 0;
    while ( i < s.length() ) {
      string::size_type j = s.find( c, i );
      if ( j == string::npos ) {
	vecStr->push_back( s.substr( i ) );
	break;
      }
      if ( i == 0 || i < j )
	vecStr->push_back( s.substr( i, j - i ) );
      i = j + 1;
    }

    return( vecStr );
  }

  /*
    string join ʸΥ٥ʸɤղäʤϢ

    vector< string >* vecStr : оݤȤʤʸΥ٥
    char c : ڤȤƻѤʸ

     : Ϣ뤷ʸ
  */
  string join( vector< string >* vecStr, char c )
  {
    string s;
    for ( vector< string >::iterator i = vecStr->begin() ; i != vecStr->end() ; i++ ) {
      s += *i;
      s += c;
    }

    return( s );
  }

  /*
    string getDateTimeFormat դʸѴ

    time_t time : 

     : Ѵʸ
  */
  string getDateTimeFormat( time_t time )
  {
    struct tm tm;
    char c[4 + 2 * 5 + 5 + 1];	// YYYY/MM/DD hh:mm:ss\0

    localtime_r( &time, &tm );
    sprintf( c, "%04d/%02d/%02d %02d:%02d:%02d", tm.tm_year + 1900, tm.tm_mon + 1,
	     tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec );
    return( c );
  }

  /*
    CharArray : ʸɤ
  */

  /*
    󥹥ȥ饯

    ̥ʸǽ
  */
  CharArray::CharArray()
    : cp( 0 )
  {
    cp = new char[1];
    cp[0] = '\0';
  }

  /*
    󥹥ȥ饯

    const string& s : оݤʸ
  */
  CharArray::CharArray( const string& s )
    : cp( 0 )
  {
    cp = new char[s.length() + 1];
    s.copy( cp, string::npos );
    cp[s.length()] = '\0';
  }

  /*
    ԡ󥹥ȥ饯

    const CharArray& c : ԡCharArray
  */
  CharArray::CharArray( const CharArray& c )
    : cp( 0 )
  {
    cp = new char[c.size() + 1];
    strncpy( cp, c.cp, c.size() );
    cp[c.size()] = '\0';
  }

  /*
    黻Ҥ¿

    const CharArray& c : CharArray
  */
  CharArray& CharArray::operator=( const CharArray& c )
  {
    if ( this == &c ) return( *this );

    delete[] cp;

    cp = new char[c.size() + 1];
    strncpy( cp, c.cp, c.size() );
    cp[c.size()] = '\0';

    return( *this );
  }
}
