#ifndef GADGET_H
#define GADGET_H

#include <string.h>

#include <string>
#include <vector>
#include <functional>
#include <iostream>

namespace Gadget
{
  using std::string;
  using std::vector;

  /* ʸѥإѴؿ */

  /*
    c_copy : stringchar*ؤѴ

    const string& s : оʸ
    char* c : Ѵ̤ϿcharؤΥݥ
    size_t size : cΥ
  */
  void c_copy( const string& s, char* c, size_t size );

  /*
    trim : ʸξüˤʸ

    const string& st : оʸ

     : ʸ
  */
  string trim( const string& st );

  /*
    cmp_str : ʸ

    const string& s1, s2 : оʸ
    bool ignoreCase : trueʸʸΰ㤤̵뤹

     : s1 < s2 ... -1 ; s1 > s2 ... 1 ; s1 = s2 ... 0
  */
  int cmp_str( const string& s1, const string& s2, bool ignoreCase = false );

  /*
    vector< string >* split ʸʸɤǶڤ

    const string& s : ʬоݤʸ
    char c : ʬ֤򼨤ʸ

     : ʬ䤷ʸΥ٥
  */
  vector< string >* split( const string& s, char c );

  /*
    string join ʸΥ٥ʸɤղäʤϢ

    vector< string >* vecStr : оݤȤʤʸΥ٥
    char c : ڤȤƻѤʸ

     : Ϣ뤷ʸ
  */
  string join( vector< string >* vecStr, char c );

  /*
    string getDateTimeFormat դʸѴ

    time_t time : 

     : Ѵʸ
  */
  string getDateTimeFormat( time_t time );

  template<class T> void qsort( vector<T>& vecT, unsigned int start, unsigned int end, const std::less<T>* less )
  {
    unsigned int s = start;
    unsigned int e = end;

    if ( s == e ) return;
    if ( e - s <= 100 ) {
      isort( vecT, s, e, less );
      return;
    }

    T mid = vecT[( s + e ) / 2];
    while ( 1 ) {
      while ( (*less)( vecT[s], mid ) ) ++s;
      while ( (*less)( mid, vecT[e] ) ) --e;
      if ( s >= e ) break;
      T t = vecT[s];
      vecT[s++] = vecT[e];
      vecT[e--] = t;
    }
    qsort( vecT, start, s - 1, less );
    qsort( vecT, s, end, less );
  }

  template<class T> void isort( vector<T>& vecT, unsigned int start, unsigned int end, const std::less<T>* less )
  {
    for ( unsigned int e = end - 1 ; e >= start ; e-- ) {
      T t = vecT[e];
      unsigned int s = e + 1;
      while ( (*less)( vecT[s], t ) && s <= end ) {
	vecT[s - 1] = vecT[s];
	++s;
      }
      vecT[s - 1] = t;
    }
  }

  /*
    CharArray : ʸɤ

    stringCʸȤưɬפѤ
  */
  class CharArray
  {
    char* cp;

  public:

    // 󥹥ȥ饯
    CharArray();
    CharArray( const string& s );
    CharArray( const CharArray& c );

    // ǥȥ饯
    ~CharArray() { delete[] cp; }

    // 黻Ҥ¿
    CharArray& operator=( const CharArray& c );

    // ʸɤ֤
    const char* data() const { return( cp ); }

    // ʸĹ֤
    unsigned int size() const { return( strlen( cp ) ); }
  };

  class CmpStr : public std::binary_function<string,string,int>
  {
    bool ignoreCase;
  public:
    CmpStr( bool nCase = false ) : ignoreCase( nCase ) {}
    int operator()( const string& s1, const string& s2 ) const
      { return( cmp_str( s1, s2, ignoreCase ) ); }
  };
  class EqStr : public std::binary_function<string,string,bool>
  {
    bool ignoreCase;
  public:
    EqStr( bool nCase = false ) : ignoreCase( nCase ) {}
    int operator()( const string& s1, const string& s2 ) const
      { return( cmp_str( s1, s2, ignoreCase ) == 0 ); }
  };
}

#endif
