#include "gtk++.h"

namespace GtkPP
{
  /****************
    إѴؿ
  ****************/

  /*
    newButton : ܥ󥦥åȤκ

    const string& stockID : ܥɽ륢Stock ID
    GtkSignalFunc clickedFunc : åΥХåؿ
    void* userData : Хåؿΰ

     : ܥ󥦥å
  */
  GtkWidget* newButton( const string& stockID, GtkSignalFunc clickedFunc, void* userData )
  {
    GtkWidget* button = gtk_button_new();
    GtkWidget* icon = gtk_image_new_from_stock( stockID.c_str(), GTK_ICON_SIZE_BUTTON );
    gtk_container_add( GTK_CONTAINER( button ), icon );

    if ( clickedFunc != 0 )
      gtk_signal_connect( GTK_OBJECT( button ), "clicked", clickedFunc, userData );

    return( button );
  }

  string convFromUTF8( const gchar* utf8 )
  {
    gsize bw;

    gchar* gc = g_locale_from_utf8( utf8, -1, 0, &bw, 0 );
    string s = gc;

    g_free( gc );

    return( s );
  }

  /************************************
    GtkUTF8 : UTF8Ѵѥ֥
  ************************************/

  /*
    󥹥ȥ饯

    const string& s (const char* c) : оʸ
  */
  GtkUTF8::GtkUTF8( const string& s )
  {
    gsize bw;
    gc = g_locale_to_utf8( s.c_str(), -1, 0, &bw, 0 );
  }
  GtkUTF8::GtkUTF8( const char* c )
  {
    gsize bw;
    gc = g_locale_to_utf8( c, -1, 0, &bw, 0 );
  }

  void GtkLessFunc::qsort( vector<string>& vecS, unsigned int start, unsigned int end )
  {
    unsigned int s = start;
    unsigned int e = end;

    if ( s == e ) return;
    if ( e - s <= 100 ) {
      isort( vecS, s, e );
      return;
    }

    string mid = vecS[( s + e ) / 2];
    while ( 1 ) {
      while ( (*this)( vecS[s], mid ) ) ++s;
      while ( (*this)( mid, vecS[e] ) ) --e;
      if ( s >= e ) break;
      string st = vecS[s];
      vecS[s++] = vecS[e];
      vecS[e--] = st;
    }
    qsort( vecS, start, s - 1 );
    qsort( vecS, s, end );
  }

  void GtkLessFunc::isort( vector<string>& vecS, unsigned int start, unsigned int end )
  {
    for ( int e = end - 1 ; e >= (int)start ; e-- ) {
      string st = vecS[e];
      int s = e + 1;
      while ( s <= (int)end ) {
	if ( ! (*this)( vecS[s], st ) ) break;
        vecS[s - 1] = vecS[s];
        ++s;
      }
      vecS[s - 1] = st;
    }
  }

  /********************************************************
    GtkCallback :Хåؿ֥ȴ쥯饹
  ********************************************************/

  bool GtkCallback::setCallback( const string& ident, const string& event, GCallback func )
  {
    if ( isConnected() )
      return( false );

    callback[ EventName( ident, event ) ] = func;

    return( true );
  }

  unsigned int GtkCallback::connect()
  {
    if ( isConnected() ) return( 0 );

    unsigned int cnt = 0;
    for ( const_iterator cit = callback.begin() ; cit != callback.end() ; ++cit ) {
      unsigned int id;
      EventName eventName = cit->first;
      if ( ! widget->connect( eventName.ident, eventName.event, cit->second, this, &id ) )
	continue;
      eventId[eventName] = id;
      ++cnt;
    }
    if ( cnt > 0 ) connectFlag = true;

    return( cnt );
  }

  unsigned int GtkCallback::disconnect()
  {
    if ( ! isConnected() ) return( 0 );

    unsigned int cnt = 0;
    vector<EventName> eventName;
    for ( mapEventId::const_iterator cit = eventId.begin() ; cit != eventId.end() ; ++cit )
      eventName.push_back( cit->first );
    for ( unsigned int i = 0 ; i < eventName.size() ; ++i ) {
      if ( ! widget->disconnect( ( eventName[i] ).ident, eventId[eventName[i]] ) )
	continue;
      eventId.erase( eventId.find( eventName[i] ) );
      ++cnt;
    }
    if ( eventId.size() == 0 ) connectFlag = false;

    return( cnt );
  }

  void GtkCallback::block()
  {
    if ( ! isConnected() ) return;

    for ( mapEventId::const_iterator cit = eventId.begin() ; cit != eventId.end() ; ++cit )
      widget->sigBlock( ( cit->first ).ident, cit->second );
  }

  void GtkCallback::unblock()
  {
    if ( ! isConnected() ) return;

    for ( mapEventId::const_iterator cit = eventId.begin() ; cit != eventId.end() ; ++cit )
      widget->sigUnblock( ( cit->first ).ident, cit->second );
  }

  void GtkCallback::printEventName() const
  {
    for ( const_iterator cit = callback.begin() ; cit != callback.end() ; ++cit ) {
      cout << "ident:" << ( cit->first ).ident;
      cout << " event:" << ( cit->first ).event;
      mapEventId::const_iterator eit = eventId.find( cit->first );
      if ( eit != eventId.end() )
	cout << " event id:" << eit->second << endl;
      else
	cout << " not connected." << endl;
    }
  }

  /********************************************************
    Dialog class : ɥ뤿Υ饹
  ********************************************************/

  /*
    󥹥ȥ饯

    GtkWindow* root : 롼ȥɥ
    const string& title : ȥ
    const string& message : å
    GtkDialogFlags flags : °
  */
  Dialog::Dialog( GtkWindow* root, const string& title, const string& message, GtkDialogFlags flags )
  {
    dialog = gtk_dialog_new_with_buttons( GtkUTF8( title ).value(), root, flags, 0 );

    GtkWidget* label = gtk_label_new( GtkUTF8( message ).value() );
    packStart( label );

    gtk_widget_show( label );
  }

  /*
    ܥɲ

    const map<string,int>& m : ܥɽƥȤȥܥ򥯥åȤͤmap
  */
  void Dialog::addButton( const map<string,int>& m )
  {
    for ( map<string,int>::const_iterator p = m.begin() ; p != m.end() ; p++ )
      addButton( p->first, p->second );
  }

  /*************************************************
    GtkBaseWidget : åȴ쥯饹
  *************************************************/

  /*
    GtkBaseWidget::addWidget : ٥ϿmapؤΥåϿ

    const string& ident : оݥ֥Ȥؤμ̻
    GObject* gObject : оݥ֥
  */
  bool GtkBaseWidget::addWidget( const string& ident, GObject* gObject )
  {
    if ( gObject == 0 ) return( false );
    if ( mapWidget.find( ident ) != mapWidget.end() )
      return( false );

    mapWidget[ident] = gObject;

    return( true );
  }

  /*
    GtkBaseWidget::removeWidget : ٥ϿmapΥåȺ

    const string& ident : оݥ֥Ȥؤμ̻
  */
  bool GtkBaseWidget::removeWidget( const string& ident )
  {
    if ( mapWidget.find( ident ) == mapWidget.end() )
      return( false );

    mapWidget.erase( ident );

    return( true );
  }

  /*
    GtkBaseWidget::bind : åȤΥХ

    const string& classIdent : 饹̾
    GtkBaseWidget& widget : Хɤ륦å
  */
  void GtkBaseWidget::bind( const string& classIdent, const GtkBaseWidget& widget )
  {
    map<string,GObject*>::const_iterator it = widget.mapWidget.begin();
    while ( it != widget.mapWidget.end() ) {
      string ident = classIdent + "." + it->first;
      if ( mapWidget.find( ident ) != mapWidget.end() )
	mapWidget.erase( ident );
      mapWidget[ident] = it->second;
      ++it;
    }
  }

  /*
    GtkBaseWidget::connect : Хåؿ³

    const string& ident : оݥ֥Ȥμ̻
    const string& event : ٥Ȥ̾
    GtkSignalFunc func : Хåؿ
    void* userData : Хåؿΰ
    unsigned int* id : ϥɥ鼱̻ҤϿݥ(פʾNULL)
  */
  bool GtkBaseWidget::connect( const string& ident, const string& event, GCallback func, void* userData, unsigned int* id )
  {
    if ( func == 0 ) return( false );
    if ( mapWidget.find( ident ) == mapWidget.end() )
      return( false );

    unsigned int i = g_signal_connect( mapWidget[ident], event.c_str(), func, userData );
    if ( id != 0 ) *id = i;

    return( true );
  }

  /*
    GtkBaseWidget::connect : Хåؿβ

    const string& ident : оݥ֥Ȥμ̻
    unsigned int id : ϥɥ鼱̻
  */
  bool GtkBaseWidget::disconnect( const string& ident, unsigned int id )
  {
    if ( mapWidget.find( ident ) == mapWidget.end() )
      return( false );

    g_signal_handler_disconnect( mapWidget[ident], id );

    return( true );
  }

  /*
    GtkBaseWidget::sigBlock : ʥΥ֥å

    const string& ident : оݥ֥Ȥμ̻
    unsigned int id : ϥɥ鼱̻
  */
  void GtkBaseWidget::sigBlock( const string& ident, unsigned int id )
  {
    if ( mapWidget.find( ident ) != mapWidget.end() )
      g_signal_handler_block( mapWidget[ident], id );
  }

  /*
    GtkBaseWidget::sigUnblock : ʥΥ֥å

    const string& ident : оݥ֥Ȥμ̻
    unsigned int id : ϥɥ鼱̻
  */
  void GtkBaseWidget::sigUnblock( const string& ident, unsigned int id )
  {
    if ( mapWidget.find( ident ) != mapWidget.end() )
      g_signal_handler_unblock( mapWidget[ident], id );
  }

  /*
    GtkBaseWidget::printWidget : Ͽ줿ʤΰϤ
  */
  void GtkBaseWidget::printWidget() const
  {
    map<string,GObject*>::const_iterator cit = mapWidget.begin();
    while ( cit != mapWidget.end() ) {
      cout << cit->first << endl;
      ++cit;
    }
  }

  /*****************************************************************
    Menu : ˥塼СΤҤȤĤΥ˥塼뤿ι¤
  *****************************************************************/

  /*
    󥹥ȥ饯

    const string& title : ˥塼Υ٥̾
  */
  Menu::Menu( const string& title )
  {
    menu = gtk_menu_new();
    createBase( gtk_menu_item_new_with_label( title.c_str() ) );

    gtk_menu_item_set_submenu( GTK_MENU_ITEM( widget() ), menu );
  }

  /*
    ֥˥塼ɲ

    const string& itemName : ֥˥塼Υ٥̾
    GCallback callback : Хå
    gpointer data : Хåؤΰ
  */
  bool Menu::addItem( const string& itemName, GCallback callback, gpointer data )
  {
    GtkWidget* item = gtk_menu_item_new_with_label( itemName.c_str() );
    if ( ! addWidget( itemName, G_OBJECT( item ) ) ) {
      g_object_unref( item );
      return( false );
    }
    gtk_menu_shell_append( GTK_MENU_SHELL( menu ), item );

    connect( itemName, "activate", callback, data );

    return( true );
  }

  /*************************************************
    GtkButtonBox : ܥܥå
  *************************************************/

  /*
    󥹥ȥ饯
  */
  GtkButtonBox::GtkButtonBox( GtkOrientation orientation )
  {
    if ( orientation == GTK_ORIENTATION_VERTICAL )
      createBase( gtk_vbox_new( FALSE, 0 ) );
    else
      createBase( gtk_hbox_new( FALSE, 0 ) );

    show();
  }

  /*
    ꤷ̻Ҥĥܥΰ֤֤

    const string& ident : ̻
  */
  int GtkButtonBox::index( const string& ident )
  {
    if ( buttonList.find( ident ) == buttonList.end() ) return( -1 );
    GtkWidget* w = buttonList[ident];

    // GValueζŪʻȤ񤫤ʤȤޤưʤ
    GValue i = {0,};
    g_value_init( &i, G_TYPE_INT );
    gtk_container_child_get_property( GTK_CONTAINER( widget() ), w, "position", &i );

    return( g_value_get_int( &i ) );
  }

  /*
    ܥɲ

    const string& ident : ̻
    const string& stockID : Stock Item Name
    GCallback callback : Хåؿ
    gpointer data : Хåؿΰ
  */
  bool GtkButtonBox::addButton( const string& ident, const string& stockID, GCallback callback, gpointer data )
  {
    if ( getWidget( ident ) != 0 ) return( false );

    GtkWidget* icon = gtk_image_new_from_stock( stockID.c_str(), GTK_ICON_SIZE_BUTTON );
    gtk_widget_show( icon );
    buttonList[ident] = gtk_button_new();
    gtk_widget_show( buttonList[ident] );
    gtk_container_add( GTK_CONTAINER( buttonList[ident] ), icon );
    gtk_box_pack_start( GTK_BOX( widget() ), buttonList[ident], TRUE, TRUE, 0 );

    addWidget( ident, G_OBJECT( buttonList[ident] ) );
    if ( callback != 0 )
      connect( ident, "clicked", callback, data );

    return( true );
  }

  /*
    ܥκ

    const string& ident : ̻

     : true ...  , false ... (ꤷ̻ҤΥܥ󤬤ʤ)
  */
  bool GtkButtonBox::removeButton( const string& ident )
  {
    if ( buttonList.find( ident ) == buttonList.end() )
      return( false );

    gtk_widget_destroy( buttonList[ident] );
    removeWidget( ident );
    buttonList.erase( ident );

    return( true );
  }

  /*
    ܥ

    const string& ident : ̻
    const string& dest : ¦оݥܥμ̻
    const string& stockID : Stock Item Name
    GCallback callback : Хåؿ
    gpointer data : Хåؿΰ

     : true ...  , false ... (ident롢ޤdestʤ)
  */
  bool GtkButtonBox::insertButton( const string& ident, const string& dest, const string& stockID, GCallback callback, gpointer data )
  {
    if ( buttonList.find( dest ) == buttonList.end() )
      return( false );
    if ( ! addButton( ident, stockID, callback, data ) )
      return( false );

    int i = index( dest );
    //if ( i < 0 ) i = GTK_PACK_START;
    gtk_box_reorder_child( GTK_BOX( widget() ), buttonList[ident], i );

    return( true );
  }


  /*************************************************
    GtkEntryWithButton : ƥȥܥåդܥ

    "entry" ... ƥѥȥ
    "button" ... ܥ
  *************************************************/

  /*
    GtkEntryWithButton::createWidget : åȤκ

    const string& stockID : GtkStockItemID
    GtkSignalFunc clickedFunc : ܥ󥯥åΥХåؿ
    void* userData : ХåؿϤ
  */
  void GtkEntryWithButton::createWidget( const string& stockID, GCallback clickedFunc, void* userData )
  {
    mainBox = gtk_hbox_new( FALSE, 0 );
    createBase( mainBox );

    widgets["entry"] = gtk_entry_new();  // ƥѥȥ
    widgets["button"] = newButton( stockID, clickedFunc, userData );  // ܥ
    gtk_box_pack_start( GTK_BOX( mainBox ), widgets["entry"], TRUE, TRUE, 0 );
    gtk_box_pack_start( GTK_BOX( mainBox ), widgets["button"], FALSE, FALSE, 0 );

    map<string,GtkWidget*>::const_iterator it = widgets.begin();
    while ( it != widgets.end() ) {
      addWidget( it->first, G_OBJECT( it->second ) );
      ++it;
    }

    show();
  }

  /***************************************************************
    GtkListStoreClass : GtkListStoreѥ饹

    "model" ...  GtkTreeViewI/F(GtkTreeModel)
  ***************************************************************/

  /*
    󥹥ȥ饯

    GtkLessFunc* _lessFunc : ƥѴؿ֥
  */
  GtkListStoreClass::GtkListStoreClass()
  {
    lessFunc = new GtkLessFunc();
    needToDeleteLessFunc = true;

    createWidget();
  }
  GtkListStoreClass::GtkListStoreClass( GtkLessFunc* _lessFunc )
  {
    lessFunc = _lessFunc;
    needToDeleteLessFunc = false;

    createWidget();
  }

  /*
    ԡ󥹥ȥ饯
  */
  GtkListStoreClass::GtkListStoreClass( const GtkListStoreClass& gtkListStoreClass )
  {
    needToDeleteLessFunc = gtkListStoreClass.needToDeleteLessFunc;
    if ( needToDeleteLessFunc )
      lessFunc = new GtkLessFunc();
    else
      lessFunc = gtkListStoreClass.lessFunc;

    createWidget();

    set<string> items = ( const_cast<GtkListStoreClass*>( &gtkListStoreClass ) )->getAllItem();
    addItem( items );
  }

  /*
    ǥȥ饯
  */
  GtkListStoreClass::~GtkListStoreClass()
  {
    if ( needToDeleteLessFunc ) delete lessFunc;
  }

  /*
    GtkListStoreClass::createWidget : åȤκ
  */
  void GtkListStoreClass::createWidget()
  {
    store = gtk_list_store_new( 1, G_TYPE_STRING );
    model = GTK_TREE_MODEL(store);

    addWidget( "model", G_OBJECT(model) );
  }

  /*
    GtkListStoreClass::funcAllItem : ƥФѽؿ

    ItemFunc pf : ؿ

     : ƥset
  */
  set<string> GtkListStoreClass::funcAllItem( ItemFunc pf )
  {
    GtkTreeIter iter;
    set<string> setS;

    gboolean hasIter = gtk_tree_model_get_iter_first( model, &iter );
    while ( hasIter ) {
      string s = (*pf)( this, &iter, &hasIter );
      setS.insert( s );
    }

    return( setS );
  }

  /*
    GtkListStoreClass::funcGivenItem : ȤϤ줿ƥФѽؿ

    ItemFunc pf : ؿ
    const set<string>& setS : ƥset

     : ƥ
  */
  unsigned int GtkListStoreClass::funcGivenItem( ItemFunc pf, const set<string>& setS )
  {
    GtkTreeIter iter;
    unsigned int cnt = 0;

    gboolean hasIter = gtk_tree_model_get_iter_first( model, &iter );
    while ( hasIter ) {
      string s = getItem( this, &iter );
      if ( setS.find( s ) != setS.end() ) {
        (*pf)( this, &iter, &hasIter );
        cnt++;
      } else {
        hasIter = gtk_tree_model_iter_next( model, &iter );
      }
    }

    return( cnt );
  }

  /*
    GtkListStoreClass::getItem : iterؤƥ

    GtkListStoreClass* list : оݤGtkListStoreClass
    GtkTreeIter* iter : listˤ륢ƥؤIter(ϼ˽٤iterؤ)
                        * âhasIter == 0 ʤiterѤʤ
    gboolean* hasIter : ˽򤹤٤Iter¸ߤ뤫

     : ƥ
  */
  string GtkListStoreClass::getItem( GtkListStoreClass* list, GtkTreeIter* iter, gboolean* hasIter )
  {
    gchar* c;
    gtk_tree_model_get( list->model, iter, 0, &c, -1 );
    if ( hasIter != 0 ) *hasIter = gtk_tree_model_iter_next( list->model, iter );
    string s = convFromUTF8( c );
    g_free( c );

    return( s );
  }

  /*
    GtkListStoreClass::removeItem : iterؤƥ

    GtkListStoreClass* list : оݤGtkListStoreClass
    GtkTreeIter* iter : listˤ륢ƥؤIter(ϼ˽٤iterؤ)
    gboolean* hasIter : ˽򤹤٤Iter¸ߤ뤫

     : ƥ
  */
  string GtkListStoreClass::removeItem( GtkListStoreClass* list, GtkTreeIter* iter, gboolean* hasIter )
  {
    gchar* c;
    gtk_tree_model_get( list->model, iter, 0, &c, -1 );
    bool b = gtk_list_store_remove( list->store, iter );
    if ( hasIter != 0 ) *hasIter = b;
    string s = convFromUTF8( c );
    g_free( c );

    return( s );
  }

  /*
    GtkListStoreClass::sortItem : ƥ¤ؤ(lessFuncѹ˻)
  */
  void GtkListStoreClass::sortItem()
  {
    set<string> setItem = getAllItem();
    clearItem();
    addItem( setItem );
  }

  /*
    GtkListStoreClass::addItem : ƥɲä

    const string& item : ɲä륢ƥ

     : ɲä ... True , ɲäǤʤä ... False
  */
  bool GtkListStoreClass::addItem( const string& item )
  {
    string s = trim( item );
    if ( s == "" ) return( false );

    GtkTreeIter iter;

    gboolean hasIter = gtk_tree_model_get_iter_first( model, &iter );
    while ( hasIter ) {
      string current = getItem( this, &iter );

      if ( (*lessFunc)( s, current ) ) {
        GtkTreeIter newIter;
        gtk_list_store_insert_before( store, &newIter, &iter );
        gtk_list_store_set( store, &newIter, 0, GtkUTF8( s ).value(), -1 );
        return( true );
      }

      if ( ! (*lessFunc)( current, s ) )
        return( false );

      hasIter = gtk_tree_model_iter_next( model, &iter );
    }

    gtk_list_store_append( store, &iter );
    gtk_list_store_set( store, &iter, 0, GtkUTF8( s ).value(), -1 );

    return( true );
  }

  /*
    GtkListStoreClass::addItem : ƥɲä

    const set<string>& setS : ɲä륢ƥset

     : ɲäƥο
  */
  unsigned int GtkListStoreClass::addItem( const set<string>& setS )
  {
    vector<string> vecS;
    copy( setS.begin(), setS.end(), back_inserter( vecS ) );
    set<string> item = getAllItem();
    copy( item.begin(), item.end(), back_inserter( vecS ) );

    if ( vecS.size() > 0 )
      qsort( vecS, 0, vecS.size() - 1 );

    clearItem();

    unsigned int cnt = 0;
    for ( unsigned int i = vecS.size() ; i > 0 ; --i )
      if ( addItem( vecS[i - 1] ) ) cnt++;

    return( cnt );
  }

  /*
    GtkListStoreClass::removeItem : ƥ

    const string& s : 륢ƥ

     :  ... True , Ǥʤä ... False
  */
  bool GtkListStoreClass::removeItem( const string& s )
  {
    set<string> setS;
    setS.insert( s );
    return( removeItem( setS ) > 0 );
  }

  /*
    GtkListStoreClass::moveAllItem : ƥư

    GtkListStoreClass* dest : ưGtkListStoreClass
  */
  set<string> GtkListStoreClass::moveAllItem( GtkListStoreClass* dest )
  {
    set<string> setS = removeAllItem();
    dest->addItem( setS );

    return( setS );
  }

  /*
    GtkListStoreClass::setLessFunc : LessFuncΥå

    Less* _lessFunc : åȤLessFunc
  */
  void GtkListStoreClass::setLessFunc( GtkLessFunc* _lessFunc )
  {
    if ( needToDeleteLessFunc ) delete lessFunc;
    lessFunc = _lessFunc;
    needToDeleteLessFunc = false;

    sortItem();
  }

  /*
    GtkListStoreClass::setLessFunc : LessFuncǥեȤ᤹
  */
  void GtkListStoreClass::resetLessFunc()
  {
    // deleteɬפʾϥǥեʤΤǽ
    if ( needToDeleteLessFunc ) return;

    lessFunc = new GtkLessFunc();
    needToDeleteLessFunc = true;

    sortItem();
  }

  /***************************************************************
    GtkComboBoxClass : GtkComboBoxѥ饹

    "model" ...  GtkTreeViewI/F(GtkTreeModel)
  ***************************************************************/

  /*
    󥹥ȥ饯

    GtkLessFunc* _lessFunc : ƥѴؿ֥
  */
  GtkComboBoxClass::GtkComboBoxClass()
    : GtkListStoreClass()
  {
    createWidget();
  }
  GtkComboBoxClass::GtkComboBoxClass( GtkLessFunc* _lessFunc )
    : GtkListStoreClass( _lessFunc )
  {
    createWidget();
  }

  /*
    ԡ󥹥ȥ饯
  */
  GtkComboBoxClass::GtkComboBoxClass( const GtkComboBoxClass& gtkComboBoxClass )
    : GtkListStoreClass( *( dynamic_cast<GtkListStoreClass*>( const_cast<GtkComboBoxClass*>( &gtkComboBoxClass ) ) ) )
  {
    createWidget();
  }

  void GtkComboBoxClass::createWidget()
  {
    combo = gtk_combo_box_new_with_model( GTK_TREE_MODEL(getStore()) );
    createBase( combo );
    addWidget( "combo", G_OBJECT(combo) );
    unrefStore();

    show();
  }

  /***************************************************************
    GtkSingleList : ñ쥢ƥɽѥꥹȥܥå

    "list" ... ꥹɽѥå(GtkTreeView)
    "model" ...  GtkTreeViewI/F(GtkTreeModel)
    "selection" ...  ƥѥ֥(GtkTreeSelection)
    "cell" ... ѥ顦֥(GtkCellRenderer)
    "column" ... 󥪥֥(GtkTreeViewColumn)
  ***************************************************************/

  /*
    󥹥ȥ饯

    const string& _dataName : ɽǡι̾
    GtkSelectionMode mode : ⡼
    GtkLessFunc* _lessFunc : ƥѴؿ֥
  */
  /*
  GtkSingleList::GtkSingleList( const string& _dataName, GtkSelectionMode mode )
   : dataName( _dataName )
  {
    lessFunc = new Less();
    needToDeleteLessFunc = true;

    createWidget( mode );
  }
  GtkSingleList::GtkSingleList( const string& _dataName, GtkSelectionMode mode, GtkLessFunc* _lessFunc )
   : dataName( _dataName )
  {
    lessFunc = _lessFunc;
    needToDeleteLessFunc = false;

    createWidget( mode );
  }
  */
  GtkSingleList::GtkSingleList( const string& _dataName, GtkSelectionMode mode )
   : GtkListStoreClass(), dataName( _dataName )
  {
    createWidget( mode );
  }
  GtkSingleList::GtkSingleList( const string& _dataName, GtkSelectionMode mode, GtkLessFunc* _lessFunc )
   : GtkListStoreClass( _lessFunc ), dataName( _dataName )
  {
    createWidget( mode );
  }
  /*
    ԡ󥹥ȥ饯
  */
  /*
  GtkSingleList::GtkSingleList( const GtkSingleList& gtkSingleList )
   : dataName( gtkSingleList.dataName )
  {
    needToDeleteLessFunc = gtkSingleList.needToDeleteLessFunc;
    if ( needToDeleteLessFunc )
      lessFunc = new Less();
    else
      lessFunc = gtkSingleList.lessFunc;

    createWidget( gtkSingleList.getMode() );

    set<string> items = ( const_cast<GtkSingleList*>( &gtkSingleList ) )->getAllItem();
    addItem( items );
  }
  */
  GtkSingleList::GtkSingleList( const GtkSingleList& gtkSingleList )
   : GtkListStoreClass( gtkSingleList ), dataName( gtkSingleList.dataName )
  {
    createWidget( gtkSingleList.getMode() );

    set<string> items = ( const_cast<GtkSingleList*>( &gtkSingleList ) )->getAllItem();
    addItem( items );
  }

  /*
    ǥȥ饯
  */
  GtkSingleList::~GtkSingleList()
  {
    //if ( needToDeleteLessFunc ) delete lessFunc;
    gtk_widget_destroy( list );
    gtk_widget_destroy( widget() );
  }

  /*
    GtkSingleList::createWidget : åȤκ

    GtkSelectionMode mode : ⡼
  */
  /*
  void GtkSingleList::createWidget( GtkSelectionMode mode )
  {
    store = gtk_list_store_new( 1, G_TYPE_STRING );
    list = gtk_tree_view_new_with_model( GTK_TREE_MODEL(store) );
    g_object_unref( G_OBJECT(store) );

    model = gtk_tree_view_get_model( GTK_TREE_VIEW(list) );

    GtkTreeSelection* selection = gtk_tree_view_get_selection( GTK_TREE_VIEW(list) );
    gtk_tree_selection_set_mode( selection, mode );

    GtkCellRenderer* cell = gtk_cell_renderer_text_new ();

    GtkTreeViewColumn* column = gtk_tree_view_column_new_with_attributes( GtkUTF8( dataName ).value(), cell, "text", 0, NULL );
    gtk_tree_view_append_column( GTK_TREE_VIEW(list), GTK_TREE_VIEW_COLUMN(column) );

    GtkWidget* scroll = gtk_scrolled_window_new( NULL, NULL );
    createBase( scroll );
    gtk_scrolled_window_set_policy( GTK_SCROLLED_WINDOW(scroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS );
    gtk_container_add( GTK_CONTAINER(scroll), list );

    addWidget( "list", G_OBJECT(list) );
    addWidget( "model", G_OBJECT(model) );
    addWidget( "selection", G_OBJECT(selection) );
    addWidget( "cell", G_OBJECT(cell) );
    addWidget( "column", G_OBJECT(column) );

    show();
  }
  */
  void GtkSingleList::createWidget( GtkSelectionMode mode )
  {
    list = gtk_tree_view_new_with_model( GTK_TREE_MODEL( getStore() ) );

    GtkTreeSelection* selection = gtk_tree_view_get_selection( GTK_TREE_VIEW(list) );
    gtk_tree_selection_set_mode( selection, mode );

    GtkCellRenderer* cell = gtk_cell_renderer_text_new ();

    GtkTreeViewColumn* column = gtk_tree_view_column_new_with_attributes( GtkUTF8( dataName ).value(), cell, "text", 0, NULL );
    gtk_tree_view_append_column( GTK_TREE_VIEW(list), GTK_TREE_VIEW_COLUMN(column) );

    GtkWidget* scroll = gtk_scrolled_window_new( NULL, NULL );
    createBase( scroll );
    gtk_scrolled_window_set_policy( GTK_SCROLLED_WINDOW(scroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS );
    gtk_container_add( GTK_CONTAINER(scroll), list );

    addWidget( "list", G_OBJECT(list) );
    addWidget( "selection", G_OBJECT(selection) );
    addWidget( "cell", G_OBJECT(cell) );
    addWidget( "column", G_OBJECT(column) );

    show();
  }

  /*
    GtkSingleList::funcSelectedItem : 򥢥ƥФѽؿ

    ItemFunc pf : ؿ

     : 򤵤Ƥƥset
  */
  set<string> GtkSingleList::funcSelectedItem( ItemFunc pf )
  {
    GtkTreeIter iter;
    set<string> setS;

    GtkTreeSelection* selection = gtk_tree_view_get_selection( GTK_TREE_VIEW(list) );
    gboolean hasIter = gtk_tree_model_get_iter_first( getModel(), &iter );
    while ( hasIter ) {
      if ( gtk_tree_selection_iter_is_selected( selection, &iter ) ) {
        string s = (*pf)( this, &iter, &hasIter );
        setS.insert( s );
      } else {
        hasIter = gtk_tree_model_iter_next( getModel(), &iter );
      }
    }

    return( setS );
  }

  /*
    GtkSingleList::funcAllItem : ƥФѽؿ

    ItemFunc pf : ؿ

     : ƥset
  */
  /*
  set<string> GtkSingleList::funcAllItem( ItemFunc pf )
  {
    GtkTreeIter iter;
    set<string> setS;

    gboolean hasIter = gtk_tree_model_get_iter_first( model, &iter );
    while ( hasIter ) {
      string s = (*pf)( this, &iter, &hasIter );
      setS.insert( s );
    }

    return( setS );
  }
  */

  /*
    GtkSingleList::funcGivenItem : ȤϤ줿ƥФѽؿ

    ItemFunc pf : ؿ
    const set<string>& setS : ƥset

     : ƥ
  */
  /*
  unsigned int GtkSingleList::funcGivenItem( ItemFunc pf, const set<string>& setS )
  {
    GtkTreeIter iter;
    unsigned int cnt = 0;

    gboolean hasIter = gtk_tree_model_get_iter_first( model, &iter );
    while ( hasIter ) {
      string s = getItem( this, &iter );
      if ( setS.find( s ) != setS.end() ) {
        (*pf)( this, &iter, &hasIter );
        cnt++;
      } else {
        hasIter = gtk_tree_model_iter_next( model, &iter );
      }
    }

    return( cnt );
  }
  */

  /*
    GtkSingleList::getItem : iterؤƥ

    GtkSingleList* list : оݤGtkSingleList
    GtkTreeIter* iter : listˤ륢ƥؤIter(ϼ˽٤iterؤ)
                        * âhasIter == 0 ʤiterѤʤ
    gboolean* hasIter : ˽򤹤٤Iter¸ߤ뤫

     : ƥ
  */
  /*
  string GtkSingleList::getItem( GtkSingleList* list, GtkTreeIter* iter, gboolean* hasIter )
  {
    gchar* c;
    gtk_tree_model_get( list->model, iter, 0, &c, -1 );
    if ( hasIter != 0 ) *hasIter = gtk_tree_model_iter_next( list->model, iter );
    string s = convFromUTF8( c );
    g_free( c );

    return( s );
  }
  */

  /*
    GtkSingleList::removeItem : iterؤƥ

    GtkSingleList* list : оݤGtkSingleList
    GtkTreeIter* iter : listˤ륢ƥؤIter(ϼ˽٤iterؤ)
    gboolean* hasIter : ˽򤹤٤Iter¸ߤ뤫

     : ƥ
  */
  /*
  string GtkSingleList::removeItem( GtkSingleList* list, GtkTreeIter* iter, gboolean* hasIter )
  {
    gchar* c;
    gtk_tree_model_get( list->model, iter, 0, &c, -1 );
    bool b = gtk_list_store_remove( list->store, iter );
    if ( hasIter != 0 ) *hasIter = b;
    string s = convFromUTF8( c );
    g_free( c );

    return( s );
  }
  */

  /*
    GtkSingleList::sortItem : ƥ¤ؤ(lessFuncѹ˻)
  */
  /*
  void GtkSingleList::sortItem()
  {
    set<string> setItem = getAllItem();
    clearItem();
    addItem( setItem );
  }
  */

  /*
    GtkSingleList::addItem : ƥɲä

    const string& item : ɲä륢ƥ

     : ɲä ... True , ɲäǤʤä ... False
  */
  /*
  bool GtkSingleList::addItem( const string& item )
  {
    string s = trim( item );
    if ( s == "" ) return( false );

    GtkTreeIter iter;

    gboolean hasIter = gtk_tree_model_get_iter_first( model, &iter );
    while ( hasIter ) {
      string current = getItem( this, &iter );

      if ( (*lessFunc)( s, current ) ) {
        GtkTreeIter newIter;
        gtk_list_store_insert_before( store, &newIter, &iter );
        gtk_list_store_set( store, &newIter, 0, GtkUTF8( s ).value(), -1 );
        return( true );
      }

      if ( ! (*lessFunc)( current, s ) )
        return( false );

      hasIter = gtk_tree_model_iter_next( model, &iter );
    }

    gtk_list_store_append( store, &iter );
    gtk_list_store_set( store, &iter, 0, GtkUTF8( s ).value(), -1 );

    return( true );
  }
  */

  /*
    GtkSingleList::addItem : ƥɲä

    const set<string>& setS : ɲä륢ƥset

     : ɲäƥο
  */
  /*
  unsigned int GtkSingleList::addItem( const set<string>& setS )
  {
    vector<string> vecS;
    copy( setS.begin(), setS.end(), back_inserter( vecS ) );
    set<string> item = getAllItem();
    copy( item.begin(), item.end(), back_inserter( vecS ) );

    if ( vecS.size() > 0 )
      qsort( vecS, 0, vecS.size() - 1 );

    clearItem();

    unsigned int cnt = 0;
    for ( unsigned int i = vecS.size() ; i > 0 ; --i )
      if ( addItem( vecS[i - 1] ) ) cnt++;

    return( cnt );
  }
  */

  /*
    GtkSingleList::removeItem : ƥ

    const string& s : 륢ƥ

     :  ... True , Ǥʤä ... False
  */
  /*
  bool GtkSingleList::removeItem( const string& s )
  {
    set<string> setS;
    setS.insert( s );
    return( removeItem( setS ) > 0 );
  }
  */

  /*
    GtkSingleList::moveSelectedItem : 򤵤줿ƥư

    GtkSingleList* dest : ưGtkSingleList
  */
  set<string> GtkSingleList::moveSelectedItem( GtkSingleList* dest )
  {
    set<string> setS = removeSelectedItem();
    dest->addItem( setS );

    return( setS );
  }

  /*
    GtkSingleList::moveAllItem : ƥư

    GtkSingleList* dest : ưGtkSingleList
  */
  /*
  set<string> GtkSingleList::moveAllItem( GtkSingleList* dest )
  {
    set<string> setS = removeAllItem();
    dest->addItem( setS );

    return( setS );
  }
  */

  /*
    GtkSingleList::setLessFunc : LessFuncΥå

    Less* _lessFunc : åȤLessFunc
  */
  /*
  void GtkSingleList::setLessFunc( Less* _lessFunc )
  {
    if ( needToDeleteLessFunc ) delete lessFunc;
    lessFunc = _lessFunc;
    needToDeleteLessFunc = false;

    sortItem();
  }
  */

  /*
    GtkSingleList::setLessFunc : LessFuncǥեȤ᤹
  */
  /*
  void GtkSingleList::resetLessFunc()
  {
    // deleteɬפʾϥǥեʤΤǽ
    if ( needToDeleteLessFunc ) return;

    lessFunc = new Less();
    needToDeleteLessFunc = true;

    sortItem();
  }
  */

  /*
    GtkSingleList::setTitle : ̾ѹ
  */
  void GtkSingleList::setTitle( string newName )
  {
    dataName = newName;
    GtkTreeViewColumn* column = gtk_tree_view_get_column( GTK_TREE_VIEW(list), 0 );
    gtk_tree_view_column_set_title( column, GtkUTF8( dataName ).value() );
  }

  /*****************************************************************
    TwinGtkList : GtkSingleList¤٤ǡѥꥹȥܥå

    "lists.left" ... ¦Υꥹ
    "lists.right" ... ¦Υꥹ
    "entry" ... ɲåƥѥȥ
    "add" ... ƥɲѥܥ
    "select" ... ƥܥ
    "deselect" ... ƥܥ
    "allselect" ... ƥܥ
    "alldeselect" ... ƥܥ
  *****************************************************************/

  /*
    󥹥ȥ饯

    const string& dataName : ɽǡι̾
    GtkSelectionMode left_mode : ¦ꥹȤ⡼
    GtkSelectionMode right_mode : ¦ꥹȤ⡼
    GtkSingleList::Less* lessFunc : ƥѴؿ֥
  */
  TwinGtkList::TwinGtkList( const string& dataName, GtkSelectionMode left_mode, GtkSelectionMode right_mode )
  {
    lists["left"] = new GtkSingleList( dataName, left_mode );
    lists["right"] = new GtkSingleList( dataName, right_mode );

    bind( "left", *( lists["left"] ) );
    bind( "right", *( lists["right"] ) );

    createWidget();
  }
  TwinGtkList::TwinGtkList( const string& dataName, GtkSelectionMode left_mode, GtkSelectionMode right_mode, GtkSingleList::Less* lessFunc )
  {
    lists["left"] = new GtkSingleList( dataName, left_mode, lessFunc );
    lists["right"] = new GtkSingleList( dataName, right_mode, lessFunc );

    bind( "left", *( lists["left"] ) );
    bind( "right", *( lists["right"] ) );

    createWidget();
  }

  /*
    TwinGtkList::createWidget : åȤκ
  */
  void TwinGtkList::createWidget()
  {
    entry = new GtkEntryWithButton( GTK_STOCK_ADD, G_CALLBACK( event_addItem ), (void*)this );
    bind( "add", *entry );

    GtkWidget* listBox = gtk_hbox_new( FALSE, 0 );

    // ܥ
    widgets["select"] = newButton( GTK_STOCK_GO_FORWARD, G_CALLBACK( event_ltr ), (void*)this );
    widgets["deselect"] = newButton( GTK_STOCK_GO_BACK, G_CALLBACK( event_rtl ), (void*)this );
    widgets["allselect"] = newButton( GTK_STOCK_MEDIA_FORWARD, G_CALLBACK( event_all_ltr ), (void*)this );
    widgets["alldeselect"] = newButton( GTK_STOCK_MEDIA_REWIND, G_CALLBACK( event_all_rtl ), (void*)this );

    map<string,GtkWidget*>::const_iterator it = widgets.begin();
    while ( it != widgets.end() ) {
      addWidget( it->first, G_OBJECT( it->second ) );
      ++it;
    }

    GtkWidget* button_box = gtk_vbox_new( FALSE, 0 );
    gtk_container_add( GTK_CONTAINER( button_box ), widgets["select"] );
    gtk_container_add( GTK_CONTAINER( button_box ), widgets["deselect"] );
    gtk_container_add( GTK_CONTAINER( button_box ), widgets["allselect"] );
    gtk_container_add( GTK_CONTAINER( button_box ), widgets["alldeselect"] );

    gtk_box_pack_start( GTK_BOX( listBox ), ( lists["left"] )->widget(), TRUE, TRUE, 0 );
    gtk_box_pack_start( GTK_BOX( listBox ), button_box, FALSE, FALSE, 0 );
    gtk_box_pack_start( GTK_BOX( listBox ), ( lists["right"] )->widget(), TRUE, TRUE, 0 );

    mainBox = gtk_vbox_new( FALSE, 0 );
    createBase( mainBox );
    gtk_box_pack_start( GTK_BOX( mainBox ), entry->widget(), FALSE, FALSE, 0 );
    gtk_box_pack_start( GTK_BOX( mainBox ), listBox, TRUE, TRUE, 0 );
  }

  /*
    ǥȥ饯
  */
  TwinGtkList::~TwinGtkList()
  {
    delete lists["left"];
    delete lists["right"];
    delete entry;
    gtk_widget_destroy( mainBox );
  }

  /*
    TwinGtkList::addItem : ƥɲ

    ƥϾ˺¦ɲä롣ɤ餫ϿѤߤΥƥϻ˺롣

    const set<string>& setS : ɲä륢ƥset

     : ɲäƥο
  */
  unsigned int TwinGtkList::addItem( const set<string>& setS )
  {
    set<string> setRight = ( lists["right"] )->getAllItem();
    set<string> setNew;
    set<string>::const_iterator p = setS.begin();
    while ( p != setS.end() ) {
      string s = trim( *p++ );
      if ( s == "" ) continue;
      if ( setRight.find( s ) == setRight.end() )
        setNew.insert( s );
    }
    return( ( lists["left"] )->addItem( setNew ) );
  }

  /*
    TwinGtkList::addItem : ƥɲ

    ƥϾ˺¦ɲä롣ɤ餫ϿѤߤξ硢ϿϤʤ

    const string& item : ɲä륢ƥ

     : ɲä ... True , ɲäǤʤä ... False
  */
  bool TwinGtkList::addItem( const string& item )
  {
    string s = trim( item );
    if ( s == "" ) return( false );

    set<string> setRight = ( lists["right"] )->getAllItem();
    if ( setRight.find( s ) != setRight.end() )
      return( false );

    return( ( lists["left"] )->addItem( s ) );
  }

  /*
    TwinGtkList::moveItem : ƥΰư

    ¦˴ޤޤʤƥȤǤ˱¦˴ޤޤ륢ƥ̵뤵

    const set<string>& setS : ư륢ƥset

     : ưƥο
  */
  unsigned int TwinGtkList::moveItem( const set<string>& setS )
  {
    set<string> setLeft = ( lists["left"] )->getAllItem();
    set<string> setRight = ( lists["right"] )->getAllItem();
    set<string> setNew;
    set<string>::const_iterator p = setS.begin();
    while ( p != setS.end() ) {
      string s = trim( *p++ );
      if ( s == "" ) continue;
      if ( setLeft.find( s ) != setLeft.end() && setRight.find( s ) == setRight.end() )
        setNew.insert( s );
    }
    ( lists["left"] )->removeItem( setNew );
    ( lists["right"] )->addItem( setNew );

    return( setNew.size() );
  }

  /*
    TwinGtkList::moveItem : ƥΰư

    ¦˴ޤޤʤƥȤǤ˱¦˴ޤޤ륢ƥ̵뤵

    const string& item : ɲä륢ƥ

     : ư ... True , ưǤʤä ... False
  */
  bool TwinGtkList::moveItem( const string& item )
  {
    string s = trim( item );
    if ( s == "" ) return( false );

    set<string> setLeft = ( lists["left"] )->getAllItem();
    set<string> setRight = ( lists["right"] )->getAllItem();

    if ( setLeft.find( s ) == setLeft.end() || setRight.find( s ) != setRight.end() )
      return( false );

    ( lists["left"] )->removeItem( s );
    ( lists["right"] )->addItem( s );

    return( true );
  }

  /*
    TwinGtkList::clearItem : ƥ

    ξꥹȤΥƥब
  */
  void TwinGtkList::clearItem()
  {
    ( lists["left"] )->clearItem();
    ( lists["right"] )->clearItem();
    addedItem.clear();
    removedItem.clear();
  }

  /*
    TwinGtkList::setMode : ⡼ɤѹ

    const string& list : ꥹȤμ̻
    GtkSelectionMode mode : ⡼
  */
  void TwinGtkList::setMode( const string& list, GtkSelectionMode mode )
  {
    if ( lists.find( list ) == lists.end() )
      return;

    ( lists[list] )->setMode( mode );
  }


  /*
    Хåؿ

    GtkButton *button : ٥ȤȯԤܥ󥦥å(̤)
    gpointer gp : оTwinGtkListؤΥݥ
  */

  /*
    TwinGtkList::event_ltr : 鱦򥢥ƥư
  */
  void TwinGtkList::event_ltr( GtkButton *button, gpointer gp )
  {
    TwinGtkList* twin = (TwinGtkList*)gp;
    twin->addedItem = ( ( twin->lists )["left"] )->moveSelectedItem( ( twin->lists )["right"] );
    ( twin->removedItem ).clear();
  }
  /*
    TwinGtkList::event_rtl : 麸򥢥ƥư
  */
  void TwinGtkList::event_rtl( GtkButton *button, gpointer gp )
  {
    TwinGtkList* twin = (TwinGtkList*)gp;
    twin->removedItem = ( ( twin->lists )["right"] )->moveSelectedItem( ( twin->lists )["left"] );
    ( twin->addedItem ).clear();
  }
  /*
    TwinGtkList::event_all_ltr : 鱦ƥư
  */
  void TwinGtkList::event_all_ltr( GtkButton *button, gpointer gp )
  {
    TwinGtkList* twin = (TwinGtkList*)gp;
    twin->addedItem = ( ( twin->lists )["left"] )->moveAllItem( ( twin->lists )["right"] );
    ( twin->removedItem ).clear();
  }
  /*
    TwinGtkList::event_all_rtl : 麸ƥư
  */
  void TwinGtkList::event_all_rtl( GtkButton *button, gpointer gp )
  {
    TwinGtkList* twin = (TwinGtkList*)gp;
    twin->removedItem = ( ( twin->lists )["right"] )->moveAllItem( ( twin->lists )["left"] );
    ( twin->addedItem ).clear();
  }
  /*
    TwinGtkList::event_addItem : entryΥƥɲä
  */
  void TwinGtkList::event_addItem( GtkButton *button, gpointer gp )
  {
    TwinGtkList* twin = (TwinGtkList*)gp;
    string gc = twin->entry->getText();
    if ( ! twin->addItem( gc ) ) return;
    if ( ! twin->moveItem( gc ) ) return;

    ( twin->addedItem ).clear();
    ( twin->addedItem ).insert( gc );
    ( twin->removedItem ).clear();

    twin->entry->setText( "" );
  }

}
