#include "pixbuf.h"

namespace GtkPP
{
  /*****************************************************
   ѥåѥ饹
  *****************************************************/

  /*
    ɤΥå
  */
  void RGB::checkCode()
  {
    for ( int i = RED ; i < SIZE ; i++ ) {
      if ( col[i] > numeric_limits<unsigned char>::max() )
	col[i] = numeric_limits<unsigned char>::max();
      if ( col[i] < 0 ) col[i] = 0;
    }
  }

  /*
    黻Ҥ¿

    const RGB& p : оݤRGB֥

     : ʻȥե
  */

  // ѥåƱΤβû
  RGB& RGB::operator+=( const RGB& p )
  {
    col[RED] += p.r();
    col[GREEN] += p.g();
    col[BLUE] += p.b();
    checkCode();

    return( *this );
  }

  // ѥåƱΤθ
  RGB& RGB::operator-=( const RGB& p )
  {
    col[RED] -= p.r();
    col[GREEN] -= p.g();
    col[BLUE] -= p.b();
    checkCode();

    return( *this );
  }

  // ѥåƱΤ¾Ū(XOR)
  RGB& RGB::operator^=( const RGB& p )
  {
    col[RED] ^= p.r();
    col[GREEN] ^= p.g();
    col[BLUE] ^= p.b();

    return( *this );
  }

  // ѥåȤΥӥåȿž
  RGB RGB::operator~()
  {
    RGB p;

    ( p.col )[RED] = ~( r() ) & 0xFF;
    ( p.col )[GREEN] = ~( g() ) & 0xFF;
    ( p.col )[BLUE] = ~( b() ) & 0xFF;

    return( p );
  }

  /*
    ʬμ
  */
  void RGB::get( unsigned char& red, unsigned char& green, unsigned char& blue, unsigned char& a ) const
  {
    red = r();
    green = g();
    blue = b();
    a = alpha();
  }
  void RGB::get( unsigned char& red, unsigned char& green, unsigned char& blue ) const
  {
    red = r();
    green = g();
    blue = b();
  }

  /*
    ؤμ(ɤν񤭹)

    unsigned char* pixel : Ƭݥ
    int n_channels : ǿ
  */
  void RGB::pset( unsigned char* pixel, int n_channels ) const
  {
    if ( n_channels >= SIZE ) n_channels = SIZE;
    for ( int i = 0 ; i < n_channels ; i++ )
      pixel[i] = col[i];
  }

  /*
    ʬΥå
  */
  void RGB::set( unsigned char r, unsigned char g, unsigned char b, unsigned char a )
  {
    col[RED] = (int)r;
    col[GREEN] = (int)g;
    col[BLUE] = (int)b;
    col[ALPHA] = (int)a;
  }

  /*
    Ǥ򥻥å(ɤμ)

    const unsigned char* pixel : Ƭݥ
    int n_channels : ǿ
  */
  void RGB::point( const unsigned char* pixel, int n_channels )
  {
    if ( n_channels > SIZE ) n_channels = SIZE;
    for ( int i = 0 ; i < n_channels ; i++ )
      col[i] = pixel[i];
  }

  /*
    YUVؤѴ
  */
  YUV RGB::toYUV() const
  {
    double y, u, v;

    getYUV( y, u, v );

    return( YUV( y, u, v, col[ALPHA] ) );
  }

  /*
    RGBʬYUVʬѴƼ

    double& y, double& u, double& v : YUVʬ
  */
  void RGB::getYUV( double& y, double& u, double& v ) const
  {
    y =	( 0.2990 * (double)col[RED] ) + ( 0.5870 * (double)col[GREEN] ) + ( 0.1140 * (double)col[BLUE] );
    u = - ( 0.1684 * (double)col[RED] ) - ( 0.3316 * (double)col[GREEN] ) + ( 0.5000 * (double)col[BLUE] );
    v =	( 0.5000 * (double)col[RED] ) - ( 0.4187 * (double)col[GREEN] ) - ( 0.0813 * (double)col[BLUE] );
  }

  /*
    󥹥ȥ饯
  */

  /*
    ʬΥå

    double y, double u, double v : YUVʬ
    unsigned char a : եͥ
  */
  void YUV::set( double y, double u, double v, unsigned char a )
  {
    col[Y] = y;
    col[U] = u;
    col[V] = v;
    Alpha = (int)a;
  }

  /*
    RGBؤѴ
  */
  RGB YUV::toRGB() const
  {
    unsigned char r, g, b;

    getRGB( r, g, b );

    return( RGB( r, g, b, Alpha ) );
  }

  /*
    YUVʬRGBʬѴ

    unsigned char& r, unsigned char& g, unsigned char& b : RGBʬ
  */
  void YUV::getRGB( unsigned char& r, unsigned char& g, unsigned char& b ) const
  {
    r = (unsigned char)( (unsigned int)( ( y()                    + ( 1.4020 * v() ) ) + 0.5 ) % 256 );
    g = (unsigned char)( (unsigned int)( ( y() - ( 0.3441 * u() ) - ( 0.7139 * v() ) ) + 0.5 ) % 256 );
    b = (unsigned char)( (unsigned int)( ( y() + ( 1.7718 * u() ) - ( 0.0012 * v() ) ) + 0.5 ) % 256 );
  }

  /*****************************************************
   PixBuf饹
  *****************************************************/

  /*
    PixbufΥԡ

    const PixBuf& dest : ԡоݤPixBuf֥
  */
  void PixBuf::copy_pixbuf( const PixBuf& dest )
  {
    if ( pixbuf != 0 ) {
      g_object_unref( pixbuf );
      pixbuf = 0;
    }

    if ( dest.pixbuf == 0 ) return;
    pixbuf = gdk_pixbuf_copy( dest.pixbuf );

    input_info();
  }

  /*
    PixBufξѿϿ
  */
  void PixBuf::input_info()
  {
    g_width = ( pixbuf != 0 ) ? gdk_pixbuf_get_width( pixbuf ) : 0;
    g_height = ( pixbuf != 0 ) ? gdk_pixbuf_get_height( pixbuf ) : 0;
    g_bps = ( pixbuf != 0 ) ? gdk_pixbuf_get_bits_per_sample( pixbuf ) : 0;
    g_rowstride = ( pixbuf != 0 ) ? gdk_pixbuf_get_rowstride( pixbuf ) : 0;
    g_n_channels = ( pixbuf != 0 ) ? gdk_pixbuf_get_n_channels( pixbuf ) : 0;
    g_xmod = ( pixbuf != 0 ) ? rowstride() - ( width() * n_channels() ) : 0;
    origin = ( pixbuf != 0 ) ? gdk_pixbuf_get_pixels( pixbuf ) : 0;
  }

  /*
    礭Τߤꤷƹ

    const Coord<unsigned int>& size : Υ
    bool has_alpha : եͥĤ
  */
  PixBuf::PixBuf( const Coord<unsigned int>& size, bool has_alpha )
    : pixbuf( 0 )
  {
    pixbuf = gdk_pixbuf_new( GDK_COLORSPACE_RGB, has_alpha, 8, size.x, size.y );
    if ( pixbuf == 0 )
      throw( PixBufException( "Not enough memory for the image buffer" ) );

    input_info();
  }

  /*
    ե뤫鹽

    const char* / string file_name : ե̾
  */
  PixBuf::PixBuf( const char* file_name )
    : pixbuf( 0 )
  {
    GError* error = 0;

    pixbuf = gdk_pixbuf_new_from_file( file_name, &error );
    if ( error != 0 ) {
      string message = convFromUTF8( error->message );
      g_error_free( error );
      throw( PixBufException( message ) );
    }
    if ( pixbuf == 0 ) {
      string message = "image buffer not created (unknown error) : file name = ";
      message += file_name;
      throw( PixBufException( message ) );
    }

    input_info();
  }
  PixBuf::PixBuf( string file_name )
    : pixbuf( 0 )
  {
    GError* error = 0;

    pixbuf = gdk_pixbuf_new_from_file( file_name.c_str(), &error );
    if ( error != 0 ) {
      string message = convFromUTF8( error->message );
      g_error_free( error );
      throw( PixBufException( message ) );
    }
    if ( pixbuf == 0 ) {
      string message = "image buffer not created (unknown error) : file name = " + file_name;
      throw( PixBufException( message ) );
    }

    input_info();
  }

  /*
    ԡ󥹥ȥ饯

    const PixBuf& dest : ԡоݤPixBuf֥
  */
  PixBuf::PixBuf( const PixBuf& dest )
    : pixbuf( 0 )
  {
    copy_pixbuf( dest );
  }

  /*
    STOCK_IDλ
  */
  PixBuf::PixBuf( GtkWidget* widget, const char* stock_id, GtkIconSize size, const char* detail )
  {
    pixbuf = gtk_widget_render_icon( widget, stock_id, size, detail );
    if ( pixbuf == 0 ) {
      string message = "Unknown stock ID : ";
      message += stock_id;
      throw( PixBufException( message ) );
    }

    input_info();
  }

  /*
    黻

    const PixBuf& dest : ԡоݤPixBuf֥

     : ʻȥե
  */
  PixBuf& PixBuf::operator=( const PixBuf& dest )
  {
    if ( this != &dest )
      copy_pixbuf( dest );

    return( *this );
  }

  /*
    ˰פƤ뤫

    const PixBuf& dest : оݤPixBuf֥

     : פƤ(true)/Ƥʤ(false)
  */
  bool PixBuf::operator==( const PixBuf& dest )
  {
    if ( pixbuf == 0 || dest.pixbuf == 0 )
      return( false );
    if ( width() != dest.width() || height() != dest.height() )
      return( false );

    guchar* p1 = origin;
    guchar* p2 = dest.origin;
    for ( int y = 0 ; y < height() ; ++y ) {
      for ( int x = 0 ; x < width() ; ++x ) {
	unsigned int c1 = *( (unsigned int*)p1 ) & ~0xFF;
	unsigned int c2 = *( (unsigned int*)p2 ) & ~0xFF;
	if ( c1 != c2 ) return( false );
	p1 += n_channels();
	p2 += dest.n_channels();
      }
      p1 += xmod();
      p2 += dest.xmod();
    }

    return( true );
  }

  /*
    ꤷɸΥѥåȤ

    const Coord<int>& c : ѥåȼоݤκɸ
    RGB& palet : ѥåȤѿ

     : True() / False(ɸϰϳ)
  */
  bool PixBuf::point( const Coord<int>& c, RGB& palet ) const
  {
    if ( c.x < 0 || c.x >= g_width ) return( false );
    if ( c.y < 0 || c.y >= g_height ) return( false );

    palet.point( origin + c.y * g_rowstride + c.x * g_n_channels, g_n_channels );

    return( true );
  }

  /*
    ꤷɸ˥ɥåȤ褹

    const Coord<int>& c : ѥåȼоݤκɸ
    const RGB& palet : 褹Υѥå

     : True() / False(ɸϰϳ)
  */
  bool PixBuf::pset( const Coord<int>& c, const RGB& palet )
  {
    if ( c.x < 0 || c.x >= g_width ) return( false );
    if ( c.y < 0 || c.y >= g_height ) return( false );

    palet.pset( origin + c.y * g_rowstride + c.x * g_n_channels, g_n_channels );

    return( true );
  }

  /*
    DrawingArea褹

    GdkDrawable* drawable : оݤGdkDrawable֥
    GdkGC* gc : Graphics Contexts
    const Coord<int>& src : 踵ɸ
    const Coord<int>& dest : 踶ɸ
    const Coord<unsigned int>& size : 褹ɸ
  */

  // DrawingAreaGdkDrawableGraphics Contexts踵θɸ
  void PixBuf::draw( GdkDrawable* drawable, GdkGC* gc, const Coord<int>& src, const Coord<int>& dest, const Coord<unsigned int>& size ) const
  {
    if ( pixbuf == 0 ) return;
    if ( has_alpha() ) {
      GdkPixbuf* buff = gdk_pixbuf_new( GDK_COLORSPACE_RGB, FALSE, bps(), size.x, size.y );
      if ( buff != 0 ) {
	gdk_pixbuf_composite_color( pixbuf, buff, 0, 0, size.x, size.y,
				    -src.x, -src.y, 1.0, 1.0,
				    GDK_INTERP_NEAREST, 255, 0, 0, 16, 0xaaaaaa, 0x555555);
	gdk_draw_pixbuf( drawable, gc, buff,
			 0, 0, dest.x, dest.y, size.x, size.y, GDK_RGB_DITHER_NORMAL, 0, 0 );
	g_object_unref( buff );
      } else { // buff˼Ԥ餽Τޤ
	gdk_draw_pixbuf( drawable, gc, pixbuf,
			 0, 0, dest.x, dest.y, size.x, size.y, GDK_RGB_DITHER_NORMAL, 0, 0 );
      }
    } else {
      gdk_draw_pixbuf( drawable, gc, pixbuf,
		       src.x, src.y, dest.x, dest.y, size.x, size.y, GDK_RGB_DITHER_NORMAL, 0, 0 );
    }
  }

  // Graphics ContextsDrawingAreaForegroundGC˸
  void PixBuf::draw( GtkWidget* drawing_area, const Coord<int>& src, const Coord<int>& dest, const Coord<unsigned int>& size ) const
  {
    draw( drawing_area->window, drawing_area->style->bg_gc[GTK_WIDGET_STATE(drawing_area)], src, dest, size );
  }

  // 踵θƱ
  void PixBuf::draw( GtkWidget* drawing_area, const Coord<int>& c, const Coord<unsigned int>& size ) const
  {
    draw( drawing_area, c, c, size );
  }

  // PixBufΤ
  void PixBuf::draw( GtkWidget* drawing_area, const Coord<int>& c ) const
  {
    draw( drawing_area, c, Coord<unsigned int>( width(), height() ) );
  }

  // 踶(0,0)˸
  void PixBuf::draw( GtkWidget* drawing_area ) const
  {
    draw( drawing_area, Coord<int>() );
  }

  /*
    礭Ѥ褹

    GdkDrawable* drawable : оݤGdkDrawable֥
    GdkGC* gc : Graphics Contexts
    const Coord<unsigned int>& size : 礭

    踵⸶ɸ(0,0)
  */
  void PixBuf::scaleDraw( GdkDrawable* drawable, const Coord<unsigned int>& size, GdkGC* gc ) const
  {
    if ( pixbuf == 0 ) return;
    GdkPixbuf* scalePixBuf = gdk_pixbuf_scale_simple( pixbuf, size.x, size.y, GDK_INTERP_HYPER );
    if ( has_alpha() ) {
      GdkPixbuf* buff = gdk_pixbuf_new( GDK_COLORSPACE_RGB, FALSE, bps(), size.x, size.y );
      if ( buff != 0 ) {
	gdk_pixbuf_composite_color( scalePixBuf, buff, 0, 0, size.x, size.y,
				    0, 0, 1.0, 1.0,
				    GDK_INTERP_NEAREST, 255, 0, 0, 16, 0xaaaaaa, 0x555555);
	gdk_draw_pixbuf( drawable, gc, buff,
			 0, 0, 0, 0, size.x, size.y, GDK_RGB_DITHER_NORMAL, 0, 0 );
	g_object_unref( buff );
      } else {
	gdk_draw_pixbuf( drawable, gc, scalePixBuf,
			 0, 0, 0, 0, size.x, size.y, GDK_RGB_DITHER_NORMAL, 0, 0 );
      }
    } else {
      gdk_draw_pixbuf( drawable, gc, scalePixBuf,
		       0, 0, 0, 0, size.x, size.y, GDK_RGB_DITHER_NORMAL, 0, 0 );
    }
    g_object_unref( scalePixBuf );
  }

  // Graphics ContextsDrawingAreaForegroundGC˸
  void PixBuf::scaleDraw( GtkWidget* drawing_area, const Coord<unsigned int>& size ) const
  {
    scaleDraw( drawing_area->window, size, drawing_area->style->bg_gc[GTK_WIDGET_STATE(drawing_area)] );
  }

  /*****************************************************
   DrawingArea饹
  *****************************************************/

  /*
    ɸκƷ׻

    widget()ΥѤäȤ䡢ޥǲɥå줿Ȥ˸ƤӽФ

    int s_size : PixBuf֥Ȥβ
    int d_size : widget()Υ
    int& s_coord : PixBuf֥Ȥθɸ
    int& d_coord : widget()θɸ
    unsigned int& g_size : 褹륵(d_sizes_sizeξ)
  */
  void DrawingArea::recalc_coord()
  {
    if ( pixbuf == 0 ) return;
    recalc_coord_sub( pixbufWidth(), widget()->allocation.width, src.x, dest.x, size.x );
    recalc_coord_sub( pixbufHeight(), widget()->allocation.height, src.y, dest.y, size.y );
  }

  void DrawingArea::recalc_coord_sub( unsigned int s_size, unsigned int d_size, int& s_coord, int& d_coord, unsigned int& g_size )
  {
    // widget()pixbuf礭ϡˤʤ褦˺ɸĴ
    if ( d_size >= s_size ) {
      s_coord = 0;
      d_coord = ( d_size - s_size ) / 2;
      g_size = s_size;
    } else {
      if ( s_coord < 0 ) s_coord = 0;
      d_coord = 0;
      // /üξ֤å
      if ( s_size - s_coord < d_size )
	s_coord = s_size - d_size;
      g_size = d_size;
    }
  }

  /*
    ޥɥåκɸ׻

    const Coord<int>& c : motion_notify_eventǼߤΥޥ
  */
  /*
  void DrawingArea::mouse_drag( const Coord& c )
  {
    src -= c;
    src += mouse;

    recalc_coord();
  }
  */

  /*
    ΰ/ѹΥ٥

    GtkWidget *widget : widget()֥
    GdkEventExpose *event : GdkEventExpose֥(̤)
    gpointer draw : DrawingArea֥(ʻȥݥ)
  */
  gint DrawingArea::configure_event( GtkWidget *widget, GdkEventExpose *event, gpointer draw )
  {
    DrawingArea* d = (DrawingArea*)draw;
    if ( d->pixbuf == 0 ) return( FALSE );
    d->recalc_coord();

    if ( d->pixmap != 0 ) g_object_unref( d->pixmap );
    d->pixmap = gdk_pixmap_new( widget->window, d->size.x, d->size.y, -1 );

    // Refresh buffer
    d->reflesh();

    return( FALSE );
  }

  /*
    Υ٥

    GtkWidget *widget : widget()֥
    GdkEventExpose *event : GdkEventExpose֥
    gpointer draw : DrawingArea֥(ʻȥݥ)
  */
  gint DrawingArea::expose_event( GtkWidget *widget, GdkEventExpose *event, gpointer draw )
  {
    DrawingArea* d = (DrawingArea*)draw;
    PixBuf* p = d->pixbuf;
    if ( p == 0 ) return( FALSE );
    Coord<int> sc, dc;
    Coord<unsigned int> szc;

    // 賫ϰ֤꺸¦ξ硢κ¦򳫻Ϥ롣
    sc.x = ( d->dest.x > event->area.x ) ? 0 : event->area.x - d->dest.x; //+ d->src.x;
    sc.y = ( d->dest.y > event->area.y ) ? 0 : event->area.y - d->dest.y; //+ d->src.y;
    dc.x = ( d->dest.x > event->area.x ) ? d->dest.x : event->area.x;
    dc.y = ( d->dest.y > event->area.y ) ? d->dest.y : event->area.y;

    szc.x = event->area.width;
    if ( sc.x + (int)szc.x > (int)p->width() ) szc.x = p->width() - sc.x;
    szc.y = event->area.height;
    if ( sc.y + (int)szc.y > (int)p->height() ) szc.y = p->height() - sc.y;

    // Refresh buffer
    d->reflesh( sc, dc, szc );

    return( FALSE );
  }

  /*
    ޥɥåΥ٥
  */
  /*
  gint DrawingArea::motion_notify_event( GtkWidget *widget, GdkEventMotion *event, gpointer draw )
  {
    DrawingArea* d = (DrawingArea*)draw;
    if ( d->pixbuf == 0 ) return( FALSE );
    Coord c;
    GdkModifierType state;

    if ( event->is_hint ) {
      gdk_window_get_pointer( event->window, &( c.x ), &( c.y ), &state );
    } else {
      c.x = (int)( event->x );
      c.y = (int)( event->y );
      state = (GdkModifierType)( event->state );
    }

    if ( ( state & GDK_BUTTON1_MASK ) && ( d->mouse.x >= 0 && d->mouse.y >= 0 ) ) {
      d->mouse_drag( c );
    } else {
      d->mouse = c;
      return( FALSE );
    }

    d->reflesh();

    d->mouse = c;

    return( TRUE );
  }
  */

  void DrawingArea::reflesh( const Coord<int>& sc, const Coord<int>& dc, const Coord<unsigned int>& sz )
  {
    if ( pixmap != 0 ) g_object_unref( pixmap );
    if ( GDK_IS_DRAWABLE( widget()->window ) ) {
      pixmap = gdk_pixmap_new( widget()->window, size.x, size.y, -1 );
      pixbuf->draw( pixmap, widget()->style->bg_gc[GTK_WIDGET_STATE(widget())], src, Coord<int>( 0, 0 ), size );
      gdk_draw_pixmap( widget()->window, widget()->style->bg_gc[GTK_WIDGET_STATE(widget())],
		       pixmap, sc.x, sc.y, dc.x, dc.y, sz.x, sz.y );
    }
  }
  void DrawingArea::reflesh() { reflesh( Coord<int>( 0, 0 ), dest, size ); }

  /*
    ٥ȥϥɥΥå
  */
  void DrawingArea::set_event()
  {
    GtkBaseWidget::connect( "drawing_area", "expose_event", G_CALLBACK( expose_event ), this );
    GtkBaseWidget::connect( "drawing_area", "configure_event", G_CALLBACK( configure_event ), this );

    gtk_widget_set_events( widget(),
			   GDK_EXPOSURE_MASK | GDK_LEAVE_NOTIFY_MASK |
			   GDK_BUTTON_PRESS_MASK | GDK_POINTER_MOTION_MASK |
			   GDK_POINTER_MOTION_HINT_MASK );
  }

  /*
    󥹥ȥ饯
  */

  /*
    ꤷƹ
  */
  DrawingArea::DrawingArea( const Coord<unsigned int>& size )
    : pixbuf( 0 ), pixmap( 0 )//, mouse( Coord( -1, -1 ) )
  {
    createBase( gtk_drawing_area_new() );
    addWidget( "drawing_area", G_OBJECT(widget()) );
    pixbuf = new PixBuf( size, false );
    recalc_coord();
    set_event();
  }

  /*
    ե̾ꤷƹ
  */
  DrawingArea::DrawingArea( const char* file_name )
    : pixbuf( 0 ), pixmap( 0 )//, mouse( Coord( -1, -1 ) )
  {
    createBase( gtk_drawing_area_new() );
    addWidget( "drawing_area", G_OBJECT(widget()) );
    load_file( file_name );
    set_event();
  }
  DrawingArea::DrawingArea( const string& file_name )
    : pixbuf( 0 ), pixmap( 0 )//, mouse( Coord( -1, -1 ) )
  {
    createBase( gtk_drawing_area_new() );
    addWidget( "drawing_area", G_OBJECT(widget()) );
    load_file( file_name );
    set_event();
  }

  /*
    ԡ󥹥ȥ饯
  */
  DrawingArea::DrawingArea( const DrawingArea& d )
    : pixbuf( 0 ), pixmap( 0 )//, mouse( Coord( -1, -1 ) )
  {
    createBase( gtk_drawing_area_new() );
    addWidget( "drawing_area", G_OBJECT(widget()) );
    pixbuf = new PixBuf( *( d.pixbuf ) );
    recalc_coord();
    set_event();
  }

  /*
    PixBufꤷƹۤ
  */
  DrawingArea::DrawingArea( const PixBuf& p )
    : pixbuf( 0 ), pixmap( 0 )//, mouse( Coord( -1, -1 ) )
  {
    createBase( gtk_drawing_area_new() );
    addWidget( "drawing_area", G_OBJECT(widget()) );
    pixbuf = new PixBuf( p );
    recalc_coord();
    set_event();
  }

  /*
    ǥȥ饯
  */
  DrawingArea::~DrawingArea()
  {
    if ( pixbuf != 0 ) delete pixbuf;
    if ( pixmap != 0 )
      g_object_unref( pixmap );
    gtk_widget_destroy( widget() );
  }

  /*
    DrawingAreaλɸPixBufФкɸ
  */
  Coord<int> DrawingArea::pixbufCoord( const Coord<int>& drawC ) const
  {
    Coord<int> c( drawC );
    c += src;
    c -= dest;

    return( c );
  }

  /*
    黻
  */
  DrawingArea& DrawingArea::operator=( const DrawingArea& d )
  {
    if ( this == &d )
      return( *this );

    if ( pixbuf != 0 ) {
      delete pixbuf;
      pixbuf = 0;
    }
    if ( d.pixbuf != 0 ) {
      pixbuf = new PixBuf( *( d.pixbuf ) );
      recalc_coord();
      set_event();
    }
    if ( pixmap != 0 ) {
      gdk_pixmap_unref( pixmap );
      pixmap = 0;
    }

    return( *this );
  }

  /*
    եɤ߹
  */
  void DrawingArea::load_file( const string& file_name )
  {
    PixBuf* newPixbuf = 0;
    try {
      newPixbuf = new PixBuf( file_name );
    } catch( exception& e ) {
      fprintf( stderr, "%s\n", e.what() );
      return;
    }

    if ( pixbuf != 0 ) delete pixbuf;
    pixbuf = newPixbuf;

    src.x = src.y = 0;

    recalc_coord();
    if ( GDK_IS_DRAWABLE( widget()->window ) )
      gdk_draw_rectangle( widget()->window, widget()->style->bg_gc[GTK_WIDGET_STATE(widget())],
                          TRUE, 0, 0, ( widget()->allocation ).width, ( widget()->allocation ).height );
    reflesh();
  }
  void DrawingArea::load_file( const char* file_name )
  {
    string s = file_name;
    load_file( s );
  }

  /*
    ޥɥåΥ٥
  */
  gint DrawingArea_MotionNotifyEvent::event( GtkWidget *widget, GdkEventMotion *event, gpointer gp )
  {
    DrawingArea_MotionNotifyEvent* d = (DrawingArea_MotionNotifyEvent*)gp;
    if ( d->drawingArea == 0 ) return( FALSE );
    Coord<int> c;
    GdkModifierType state;

    if ( event->is_hint ) {
      gdk_window_get_pointer( event->window, &( c.x ), &( c.y ), &state );
    } else {
      c.x = (int)( event->x );
      c.y = (int)( event->y );
      state = (GdkModifierType)( event->state );
    }

    if ( ( state & GDK_BUTTON1_MASK ) && ( d->mouse.x >= 0 && d->mouse.y >= 0 ) ) {
      Coord<int> buff( c );
      buff -= d->mouse;
      d->drawingArea->rdShift( buff );
    } else {
      d->mouse = c;
      return( FALSE );
    }

    d->drawingArea->reflesh();

    d->mouse = c;

    return( TRUE );
  }

  void DrawingArea_MotionNotifyEvent::connect( DrawingArea& da )
  {
    drawingArea = &da;
    da.GtkBaseWidget::connect( "drawing_area", "motion_notify_event", G_CALLBACK( event ), this );
  }

}
